Index: trunk/source/processes/electromagnetic/standard/History
===================================================================
--- trunk/source/processes/electromagnetic/standard/History	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/History	(revision 1055)
@@ -1,3 +1,3 @@
-$Id: History,v 1.430 2008/11/24 18:28:09 vnivanch Exp $
+$Id: History,v 1.452 2009/05/18 12:31:46 vnivanch Exp $
 -------------------------------------------------------------------
 
@@ -17,4 +17,80 @@
      * Reverse chronological order (last date on top), please *
      ----------------------------------------------------------
+
+18 May 09:  V.Ivant (emstand-V09-02-12)
+- G4UrbanMscModel2  - (L.Urban) correction in tail tuning using MuScat data
+
+15 May 09:  V.Ivant (emstand-V09-02-11)
+- G4WaterStopping  - fixed Ar data
+- G4PairProductionRelModel - (A.Schaelicke) new relativistic model for 
+                              gamma conversion
+- G4UrbanMscModel2  - (L.Urban) new version of theta0 and tail tuning
+
+10 May 09: V.Ivant (emstand-V09-02-10)
+- G4WentzelVIModel, G4eCoulombScattering, G4CoulombScattering - added relativistic
+                      factor to Reserford cross section; set default limit on
+                      kinetic energy of the recoil 100 keV
+
+28 April 09: V.Ivant (emstand-V09-02-09)
+- G4UrbanMscModel2  - (L.Urban) new tuning for the central part and for the 
+                      tail of the angular distribution using the old e- 
+                      scattering data only (Phys. Rev. 84 (1951) 634; 
+                      Phys. Rev. 61 (1942) 254) 
+                    - corrected logic in ComputeTruePathLengthLimit method 
+                      for type=fUseDistanceToBoundary
+- G4UrbanMscModel   - frozen version of G4UrbanMscModel2 of g4 9.2
+- G4WentzelVIModel, G4eCoulombScattering  - reduce low-limit from 1 keV to 0.1 keV 
+                      to provide smooth transport cross section table
+
+23 April 09: V.Ivant (emstand-V09-02-08)
+- G4BetheBlochModel - do not use pointer to GenericIon introduced in the
+                      previous tag due to problem of simple PhysLists without ions
+
+20 April 09: V.Ivant (emstand-V09-02-07)
+- G4BetheBlochModel - fixed and simplified initialisation for ions needed for
+                      the new G4IonParametrisedLossModel of low-energy package
+- G4GoudsmitSaundersonMscModel - (O.Kadri) cleanup: discarded no scattering and 
+                      single scattering theta sampling from SampleCosineTheta() 
+                      which means the splitting step into two sub-steps occur 
+                      only for msc regime  
+
+12 April 09: V.Ivant (emstand-V09-02-06)
+- Simplified initialisation of all models
+- G4UrbanMscModel, G4UrbanMscModel2, G4UrbanMscModel90 - use methods
+   of G4VMscModel for interface to geometry
+
+07 April 09: V.Ivant (emstand-V09-02-05)
+- G4IonFluctuations - T.Toshito removed extra phenomenological factor
+                      in fluctuation width
+- G4HeatedKleinNishinaCompton - V.Grichine added a prototype model for
+                                plasma 
+
+21 March 09: V.Ivant (emstand-V09-02-04)
+- G4UniversalFluctuation - L.Urban introduce modification in width 
+    correction, the dependence of the correction on energy deposition 
+    at previous steps is removed (addresses T2K report)
+
+20 March 09: V.Ivant (emstand-V09-02-03)
+- G4GoudsmitSaundersonMscModel fixed compillation problem
+
+12 March 09: V.Ivant (emstand-V09-02-02)
+- G4GoudsmitSaundersonMscModel fixed compillation problem
+- G4UniversalFluctuation - add temporary fix for T2K report
+
+05 March 09: V.Ivant (emstand-V09-02-01)
+- New G4GoudsmitSaundersonMscModel is added
+- G4WentzelVIModel, G4eCoulombScattringModel:
+    o substitute scaling of low-energy limit by setting 1 keV for 
+      all particles;
+    o use EGSnrc form of screening parameter (second order correction) 
+
+20 February 09: V.Ivant (emstand-V09-02-00)
+- Move all virtual methods from inline to source
+G4PEEffectModel - substitute ComputeMeanFreePath by CrossSectionPerVolume 
+                  (minor CPU speadup for compound materials)
+G4PAIModel, G4PAIPhotonModel - remove usage of random numbers at 
+                   initialisation (potential non-reproducibility)
+G4WentzelVIModel - use generic methods of G4VMscModel to access safety
+                   and other geometry information 
 
 24 November 08: V.Ivant (emstand-V09-01-45)
Index: trunk/source/processes/electromagnetic/standard/include/G4BetheBlochModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4BetheBlochModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4BetheBlochModel.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BetheBlochModel.hh,v 1.16 2008/10/22 16:00:57 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4BetheBlochModel.hh,v 1.20 2009/04/23 17:44:43 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -64,9 +64,8 @@
 
 #include "G4VEmModel.hh"
+#include "G4NistManager.hh"
 
 class G4EmCorrections;
 class G4ParticleChangeForLoss;
-class G4NistManager;
-
 
 class G4BetheBlochModel : public G4VEmModel
@@ -82,6 +81,6 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  G4double MinEnergyCut(const G4ParticleDefinition*,
-			const G4MaterialCutsCouple*);
+  virtual G4double MinEnergyCut(const G4ParticleDefinition*,
+				const G4MaterialCutsCouple*);
 			
   virtual G4double ComputeCrossSectionPerElectron(
@@ -131,10 +130,14 @@
 protected:
 
-  G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-			      G4double kinEnergy);
+  virtual G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
+				      G4double kinEnergy);
 
 private:
 
-  void SetParticle(const G4ParticleDefinition* p);
+  inline void SetupParameters();
+
+  inline void SetParticle(const G4ParticleDefinition* p);
+
+  inline void SetGenericIon(const G4ParticleDefinition* p);
 
   // hide assignment operator
@@ -166,16 +169,45 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-inline G4double G4BetheBlochModel::MaxSecondaryEnergy(
-          const G4ParticleDefinition* pd,
-                G4double kinEnergy) 
-{
-  if(isIon) SetParticle(pd);
-  G4double tau  = kinEnergy/mass;
-  G4double tmax = 2.0*electron_mass_c2*tau*(tau + 2.) /
-                  (1. + 2.0*(tau + 1.)*ratio + ratio*ratio);
-  return std::min(tmax,tlimit);
+inline void G4BetheBlochModel::SetupParameters()
+{
+  mass = particle->GetPDGMass();
+  spin = particle->GetPDGSpin();
+  G4double q = particle->GetPDGCharge()/eplus;
+  chargeSquare = q*q;
+  ratio = electron_mass_c2/mass;
+  G4double magmom = particle->GetPDGMagneticMoment()*mass/(0.5*eplus*hbar_Planck*c_squared);
+  magMoment2 = magmom*magmom - 1.0;
+  formfact = 0.0;
+  if(particle->GetLeptonNumber() == 0) {
+    G4double x = 0.8426*GeV;
+    if(spin == 0.0 && mass < GeV) {x = 0.736*GeV;}
+    else if(mass > GeV) {
+      x /= nist->GetZ13(mass/proton_mass_c2);
+      //	tlimit = 51.2*GeV*A13[iz]*A13[iz];
+    }
+    formfact = 2.0*electron_mass_c2/(x*x);
+    tlimit   = 2.0/formfact;
+  }
 }
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
+inline void G4BetheBlochModel::SetParticle(const G4ParticleDefinition* p)
+{
+  if(particle != p) {
+    particle = p;
+    if (p->GetPDGCharge()/eplus > 1.5 && p->GetBaryonNumber() > 2) isIon = true;
+    SetupParameters();
+  }
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline void G4BetheBlochModel::SetGenericIon(const G4ParticleDefinition* p)
+{
+  if(p && particle != p) {
+    if(p->GetParticleName() == "GenericIon") isIon = true;
+  }
+}
+
 #endif
Index: trunk/source/processes/electromagnetic/standard/include/G4BohrFluctuations.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4BohrFluctuations.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4BohrFluctuations.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BohrFluctuations.hh,v 1.3 2007/09/27 13:53:11 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4BohrFluctuations.hh,v 1.4 2009/02/19 19:17:50 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -79,6 +79,4 @@
   void InitialiseMe(const G4ParticleDefinition*);
 
-protected:
-
 private:
 
@@ -103,25 +101,4 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-
-inline G4double G4BohrFluctuations::Dispersion(
-                          const G4Material* material,
-                          const G4DynamicParticle* dp,
- 				G4double& tmax,
-			        G4double& length)
-{
-  if(!particle) InitialiseMe(dp->GetDefinition());
-
-  G4double electronDensity = material->GetElectronDensity();
-  kineticEnergy = dp->GetKineticEnergy();
-  G4double etot = kineticEnergy + particleMass;
-  beta2 = kineticEnergy*(kineticEnergy + 2.0*particleMass)/(etot*etot);
-  G4double siga  = (1.0/beta2 - 0.5) * twopi_mc2_rcl2 * tmax * length
-                 * electronDensity * chargeSquare;
-
-  return siga;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
 #endif
 
Index: trunk/source/processes/electromagnetic/standard/include/G4BraggIonModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4BraggIonModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4BraggIonModel.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BraggIonModel.hh,v 1.11 2008/10/22 16:00:57 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4BraggIonModel.hh,v 1.12 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -77,6 +77,6 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  G4double MinEnergyCut(const G4ParticleDefinition*,
-			const G4MaterialCutsCouple*);
+  virtual G4double MinEnergyCut(const G4ParticleDefinition*,
+				const G4MaterialCutsCouple*);
 			
   virtual G4double ComputeCrossSectionPerElectron(
@@ -128,6 +128,6 @@
 protected:
 
-  G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-			      G4double kinEnergy);
+  virtual G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
+				      G4double kinEnergy);
 
 private:
@@ -180,17 +180,4 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
-inline G4double G4BraggIonModel::MaxSecondaryEnergy(
-          const G4ParticleDefinition* pd,
-                G4double kinEnergy)
-{
-  if(pd != particle) SetParticle(pd);
-  G4double tau  = kinEnergy/mass;
-  G4double tmax = 2.0*electron_mass_c2*tau*(tau + 2.) /
-                  (1. + 2.0*(tau + 1.)*ratio + ratio*ratio);
-  return tmax;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
 inline void G4BraggIonModel::SetParticle(const G4ParticleDefinition* p)
 {
Index: trunk/source/processes/electromagnetic/standard/include/G4BraggModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4BraggModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4BraggModel.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BraggModel.hh,v 1.12 2008/09/14 17:11:48 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4BraggModel.hh,v 1.13 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -80,6 +80,6 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  G4double MinEnergyCut(const G4ParticleDefinition*,
-			const G4MaterialCutsCouple*);
+  virtual G4double MinEnergyCut(const G4ParticleDefinition*,
+				const G4MaterialCutsCouple*);
 			
   virtual G4double ComputeCrossSectionPerElectron(
@@ -131,10 +131,10 @@
 protected:
 
-  G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-			      G4double kinEnergy);
+  virtual G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
+				      G4double kinEnergy);
 
 private:
 
-  void SetParticle(const G4ParticleDefinition* p);
+  inline void SetParticle(const G4ParticleDefinition* p);
 
   G4bool HasMaterial(const G4Material* material);
@@ -182,17 +182,4 @@
   G4bool   isInitialised;
 };
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-inline G4double G4BraggModel::MaxSecondaryEnergy(
-                                            const G4ParticleDefinition* pd,
-                                                  G4double kinEnergy)
-{
-  if(pd != particle) SetParticle(pd);
-  G4double tau  = kinEnergy/mass;
-  G4double tmax = 2.0*electron_mass_c2*tau*(tau + 2.) /
-                  (1. + 2.0*(tau + 1.)*ratio + ratio*ratio);
-  return tmax;
-}
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/source/processes/electromagnetic/standard/include/G4ComptonScattering.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4ComptonScattering.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4ComptonScattering.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ComptonScattering.hh,v 1.20 2007/05/23 08:47:34 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4ComptonScattering.hh,v 1.21 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //------------------ G4ComptonScattering physics process -----------------------
@@ -82,9 +82,8 @@
 
   // true for Gamma only.  
-  G4bool IsApplicable(const G4ParticleDefinition&);
+  virtual G4bool IsApplicable(const G4ParticleDefinition&);
   
   // Print few lines of informations about the process: validity range,
   virtual void PrintInfo();
-
 
 protected:
@@ -97,13 +96,4 @@
 };
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline 
-G4bool G4ComptonScattering::IsApplicable(const G4ParticleDefinition& p)
-{
-  return (&p == G4Gamma::Gamma());
-}
-
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
   
Index: trunk/source/processes/electromagnetic/standard/include/G4CoulombScattering.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4CoulombScattering.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4CoulombScattering.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4CoulombScattering.hh,v 1.11 2008/06/13 08:19:43 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4CoulombScattering.hh,v 1.13 2009/05/07 18:41:45 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -59,5 +59,5 @@
 public:
 
-  G4CoulombScattering(const G4String& name = "eCoulombScat");
+  G4CoulombScattering(const G4String& name = "CoulombScat");
 
   virtual ~G4CoulombScattering();
@@ -104,11 +104,4 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-inline G4bool G4CoulombScattering::IsApplicable(const G4ParticleDefinition& p)
-{
-  return (p.GetPDGCharge() != 0.0 && !p.IsShortLived());
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
 inline void G4CoulombScattering::SetThetaMin(G4double val)
 {
Index: trunk/source/processes/electromagnetic/standard/include/G4GammaConversion.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4GammaConversion.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4GammaConversion.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GammaConversion.hh,v 1.22 2007/05/23 08:47:34 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4GammaConversion.hh,v 1.23 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
@@ -85,5 +85,5 @@
 
   // true for Gamma only.
-  G4bool IsApplicable(const G4ParticleDefinition&);
+  virtual G4bool IsApplicable(const G4ParticleDefinition&);
 
   // Print few lines of informations about the process: validity range,
@@ -99,12 +99,4 @@
 };
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4bool G4GammaConversion::IsApplicable(const G4ParticleDefinition& p)
-{
-  return (&p == G4Gamma::Gamma());
-}
-
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
   
Index: trunk/source/processes/electromagnetic/standard/include/G4IonFluctuations.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4IonFluctuations.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4IonFluctuations.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4IonFluctuations.hh,v 1.8 2008/10/22 16:04:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4IonFluctuations.hh,v 1.9 2009/02/19 19:17:50 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -84,5 +84,5 @@
 
   // Initialisation prestep
-  inline void SetParticleAndCharge(const G4ParticleDefinition*, G4double q2);
+  void SetParticleAndCharge(const G4ParticleDefinition*, G4double q2);
 
 private:
@@ -117,20 +117,4 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-inline
-void G4IonFluctuations::SetParticleAndCharge(const G4ParticleDefinition* part,
-					     G4double q2)
-{
-  if(part != particle) {
-    particle       = part;
-    particleMass   = part->GetPDGMass();
-    charge         = part->GetPDGCharge()/eplus;
-    chargeSquare   = charge*charge;
-  }
-  effChargeSquare  = q2;
-  uniFluct.SetParticleAndCharge(part, q2);
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
 #endif
 
Index: trunk/source/processes/electromagnetic/standard/include/G4MollerBhabhaModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4MollerBhabhaModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4MollerBhabhaModel.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4MollerBhabhaModel.hh,v 1.19 2007/05/22 17:34:36 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4MollerBhabhaModel.hh,v 1.20 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -74,6 +74,6 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  G4double MinEnergyCut(const G4ParticleDefinition*,
-			const G4MaterialCutsCouple*);
+  virtual G4double MinEnergyCut(const G4ParticleDefinition*,
+				const G4MaterialCutsCouple*);
 				
   virtual G4double ComputeCrossSectionPerElectron(
@@ -109,8 +109,8 @@
 protected:
 
-  G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-			      G4double kinEnergy);
+  virtual G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
+				      G4double kinEnergy);
 			      
-  void SetParticle(const G4ParticleDefinition* p);			      
+  inline void SetParticle(const G4ParticleDefinition* p);			      
 
   const G4ParticleDefinition* particle;
@@ -127,15 +127,15 @@
   G4MollerBhabhaModel & operator=(const  G4MollerBhabhaModel &right);
   G4MollerBhabhaModel(const  G4MollerBhabhaModel&);
+
+  G4bool   isInitialised;
+
 };
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
-inline G4double G4MollerBhabhaModel::MaxSecondaryEnergy(
-                                                   const G4ParticleDefinition*,
-                                                         G4double kinEnergy) 
+inline void G4MollerBhabhaModel::SetParticle(const G4ParticleDefinition* p)
 {
-  G4double tmax = kinEnergy;
-  if(isElectron) tmax *= 0.5;
-  return tmax;
+  particle = p;
+  if(p != theElectron) isElectron = false;
 }
 
Index: trunk/source/processes/electromagnetic/standard/include/G4PAIModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4PAIModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4PAIModel.hh	(revision 1055)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// $Id: G4PAIModel.hh,v 1.22 2009/02/19 19:17:50 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -75,12 +77,12 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  virtual void InitialiseMe(const G4ParticleDefinition*) {};
-
-  virtual G4double ComputeDEDX(const G4MaterialCutsCouple*,
+  virtual void InitialiseMe(const G4ParticleDefinition*);
+
+  virtual G4double ComputeDEDXPerVolume(const G4Material*,
 			       const G4ParticleDefinition*,
 			       G4double kineticEnergy,
 			       G4double cutEnergy);
 
-  virtual G4double CrossSection(const G4MaterialCutsCouple*,
+  virtual G4double CrossSectionPerVolume(const G4Material*,
 				const G4ParticleDefinition*,
 				G4double kineticEnergy,
@@ -118,6 +120,4 @@
 
   void SetVerboseLevel(G4int verbose){fVerbose=verbose;};
-
-
 
 protected:
@@ -192,28 +192,4 @@
 };
 
-/////////////////////////////////////////////////////////////////////
-
-inline G4double G4PAIModel::MaxSecondaryEnergy( const G4ParticleDefinition* p,
-                                                      G4double kinEnergy) 
-{
-  G4double tmax = kinEnergy;
-  if(p == fElectron) tmax *= 0.5;
-  else if(p != fPositron) { 
-    G4double mass = p->GetPDGMass();
-    G4double ratio= electron_mass_c2/mass;
-    G4double gamma= kinEnergy/mass + 1.0;
-    tmax = 2.0*electron_mass_c2*(gamma*gamma - 1.) /
-                  (1. + 2.0*gamma*ratio + ratio*ratio);
-  }
-  return tmax;
-}
-
-///////////////////////////////////////////////////////////////
-
-inline  void G4PAIModel::DefineForRegion(const G4Region* r) 
-{
-  fPAIRegionVector.push_back(r);
-}
-
 #endif
 
Index: trunk/source/processes/electromagnetic/standard/include/G4PAIPhotonModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4PAIPhotonModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4PAIPhotonModel.hh	(revision 1055)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// $Id: G4PAIPhotonModel.hh,v 1.12 2009/02/19 19:17:50 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -74,16 +76,16 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
   
-  virtual void InitialiseMe(const G4ParticleDefinition*) {};
-
-  virtual G4double ComputeDEDX(const G4MaterialCutsCouple*,
-			       const G4ParticleDefinition*,
-			       G4double kineticEnergy,
-			       G4double cutEnergy);
-
-  virtual G4double CrossSection(const G4MaterialCutsCouple*,
-				const G4ParticleDefinition*,
-				G4double kineticEnergy,
-				G4double cutEnergy,
-				G4double maxEnergy);
+  virtual void InitialiseMe(const G4ParticleDefinition*);
+
+  virtual G4double ComputeDEDXPerVolume(const G4Material*,
+					const G4ParticleDefinition*,
+					G4double kineticEnergy,
+					G4double cutEnergy);
+
+  virtual G4double CrossSectionPerVolume(const G4Material*,
+					 const G4ParticleDefinition*,
+					 G4double kineticEnergy,
+					 G4double cutEnergy,
+					 G4double maxEnergy);
 
   virtual void SampleSecondaries(std::vector<G4DynamicParticle*>*,
@@ -122,10 +124,8 @@
                              G4double position, G4int iTransfer );
 
-
-
 protected:
 
   G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-                                    G4double kinEnergy);
+			      G4double kinEnergy);
 
 private:
@@ -145,6 +145,4 @@
   G4int                fVerbose; 
   G4PhysicsLogVector*  fProtonEnergyVector ;
-
-
 
   // vectors
@@ -204,28 +202,4 @@
 };
 
-/////////////////////////////////////////////////////////////////////
-
-inline G4double G4PAIPhotonModel::MaxSecondaryEnergy( const G4ParticleDefinition* p,
-                                                      G4double kinEnergy) 
-{
-  G4double tmax = kinEnergy;
-  if(p == fElectron) tmax *= 0.5;
-  else if(p != fPositron) { 
-    G4double mass = p->GetPDGMass();
-    G4double ratio= electron_mass_c2/mass;
-    G4double gamma= kinEnergy/mass + 1.0;
-    tmax = 2.0*electron_mass_c2*(gamma*gamma - 1.) /
-                  (1. + 2.0*gamma*ratio + ratio*ratio);
-  }
-  return tmax;
-}
-
-///////////////////////////////////////////////////////////////
-
-inline  void G4PAIPhotonModel::DefineForRegion(const G4Region* r) 
-{
-  fPAIRegionVector.push_back(r);
-}
-
 #endif
 
Index: trunk/source/processes/electromagnetic/standard/include/G4PEEffectModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4PEEffectModel.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4PEEffectModel.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PEEffectModel.hh,v 1.6 2007/05/22 17:34:36 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PEEffectModel.hh,v 1.7 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -41,4 +41,6 @@
 //
 // 06.02.2006 : added ComputeMeanFreePath()  (mma)
+// 20.02.2009 : move virtual inline to .cc, substitute
+//              ComputeMeanFreePath() by CrossSectionPerVolume (VI)
 //
 // Class Description:
@@ -70,14 +72,15 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  G4double ComputeCrossSectionPerAtom(const G4ParticleDefinition*,
-                                      G4double kinEnergy,
-                                      G4double Z,
-                                      G4double A,
-                                      G4double, G4double);
+  virtual G4double ComputeCrossSectionPerAtom(const G4ParticleDefinition*,
+					      G4double kinEnergy,
+					      G4double Z,
+					      G4double A,
+					      G4double, G4double);
 				      
-  G4double ComputeMeanFreePath( const G4ParticleDefinition*,
-                                      G4double kinEnergy,
-				const G4Material* material,      
-                                      G4double, G4double);
+  virtual G4double CrossSectionPerVolume(const G4Material*,
+					 const G4ParticleDefinition*,
+					 G4double kineticEnergy,
+					 G4double cutEnergy,
+					 G4double maxEnergy);
 
   virtual void SampleSecondaries(std::vector<G4DynamicParticle*>*,
@@ -100,43 +103,4 @@
 };
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo.....
-
-inline G4double G4PEEffectModel::ComputeCrossSectionPerAtom(
-                                       const G4ParticleDefinition*,
-                                             G4double energy,
-                                             G4double Z, G4double,
-                                             G4double, G4double)
-{
- G4double* SandiaCof = G4SandiaTable::GetSandiaCofPerAtom((G4int)Z, energy);
-
- G4double energy2 = energy*energy, energy3 = energy*energy2,
-          energy4 = energy2*energy2;
-
- return SandiaCof[0]/energy  + SandiaCof[1]/energy2 +
-        SandiaCof[2]/energy3 + SandiaCof[3]/energy4;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline G4double G4PEEffectModel::ComputeMeanFreePath(
-                                       const G4ParticleDefinition*,
-                                             G4double energy,
-				       const G4Material* material,
-                                             G4double, G4double)
-{
- G4double* SandiaCof = material->GetSandiaTable()
-                                ->GetSandiaCofForMaterial(energy);
-				
- G4double energy2 = energy*energy, energy3 = energy*energy2,
-          energy4 = energy2*energy2;
-	  
- G4double cross = SandiaCof[0]/energy  + SandiaCof[1]/energy2 +
-                  SandiaCof[2]/energy3 + SandiaCof[3]/energy4; 
- 
- G4double mfp = DBL_MAX;
- if (cross > 0.) mfp = 1./cross;
- return mfp;
-}
-
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
Index: trunk/source/processes/electromagnetic/standard/include/G4PhotoElectricEffect.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4PhotoElectricEffect.hh	(revision 1007)
+++ trunk/source/processes/electromagnetic/standard/include/G4PhotoElectricEffect.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4PhotoElectricEffect.hh,v 1.24 2007/05/23 08:47:34 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PhotoElectricEffect.hh,v 1.25 2009/02/20 12:06:37 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
@@ -91,12 +91,12 @@
 
   // true for Gamma only.
-  G4bool IsApplicable(const G4ParticleDefinition&);
+  virtual G4bool IsApplicable(const G4ParticleDefinition&);
 
   // Print few lines of informations about the process: validity range,
-  void PrintInfo();
+  virtual void PrintInfo();
 
 protected:
 
-  void InitialiseProcess(const G4ParticleDefinition*);
+  virtual void InitialiseProcess(const G4ParticleDefinition*);
 
 private:
@@ -105,13 +105,4 @@
 };
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
-
-inline 
-G4bool G4PhotoElectricEffect::IsApplicable(const G4ParticleDefinition& p)
-{
-  return (&p == G4Gamma::Gamma());
-}
-
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
